<!doctype html>
<html lang= "en">
<head>
    <meta charset= "utf-8">
    <title> Javascript Big Integers</title>
    <style>
        body{margin: 0 1em;width: auto;font-size: 125%}p{max-width: 800px;margin: 1ex 1em;}div{margin: 1em;}input, textarea, label{font-size: 1em;line-height: 1.2;font-family: arial, sans-serif;font-weight: 600;padding: 0 2px;}textarea{background-color: white;    color: black;   width: 90%;border: 2px ridge silver;position: absolute;z-index: 5;overflow-y: scroll;height: 500px;}#unicorn{text-align: center;}#unicorn img{width: 15%;}#fibInp{text-align: right;}#calcfibBtn, #stopFibBtn{color:navy;cursor:pointer}#calcfibBtn:focus, #stopFibBtn:focus, #calcfibBtn:hover, #stopFibBtn:hover{color:red}
    </style>
</head>

<body>
    <h2 style="text-align: center;" id= "yw_fib_head"> Fibonacci numbers in javascript</h2>
    <div id="unicorn">
        <img src="http://cs618117.vk.me/v618117981/1c08/fY0icozBRew.jpg" alt="">
    </div>
    <div id="magic">
        <label> fibonacci from 0 to <input size= "5" id= "fibInp" type= "text" value= "333"> </label>
        <input type= "button" id= "calcfibBtn" value= "Calculate">
        <input type= "button" id= "stopFibBtn" value= "Stop">
    </div>
    <script>
        function mr(a){if(a){if("string"==typeof a)return document.getElementById(a);if(1===a.nodeType)return a}return null}Array.prototype.map||(Array.prototype.map=function(a,b){var c=this.length,f=Array(this.length),e=0;if("function"==typeof a){for(;e<c;)e in this&&(f[e]=a.call(b,this[e],e,this)),++e;return f}});
        function BigInt(a,b){if(this.constructor!=BigInt){if(a.constructor==BigInt)return a;a=a.toString();if(/^\d+$/.test(a)){var c=a.split("").map(Number);return new BigInt(c.reverse(),b)}throw Error("base 10 integer input only");}for(;a.length&&!a[a.length-1];)--a.length;this.digits=a;this.length=a.length;-1==b&&(this.sign=b)}BigInt.prototype.toString=function(){var a=this.digits.slice().reverse().join("");-1==this.sign&&(a="-"+a);return a};
        BigInt.prototype.plus=function(a){a=BigInt(a);var b=this.digits;a=a.digits;for(var c=b.length,f=a.length,e=Array(Math.max(c,f)+1),g=Math.min(c,f),d=0,h=0;h<g;h++)d=b[h]+a[h]+d,e[h]=d%10,d=d/10|0;f>c&&(b=a,c=f);for(h=g;d&&h<c;h++)d=b[h]+d,e[h]=d%10,d=d/10|0;for(d&&(e[h]=d);h<c;)e[h]=b[h],++h;return new BigInt(e)};
        Math.fibonacci=function(a){for(var b=0,c,f=1,e=[],g=0;9007199254740992>b;){e[g++]=b;if(g==a)return e;c=f;f=b+c;b=c}if(a)for(f=e.pop(),b=e.pop(),g=e.length;g<a;)e[g++]=b,c=BigInt(f),f=c.plus(b),b=c.toString();return e};Math.nthFibonacci=function(a,b){for(var c=[0,1],f=78;a&&--f;)c[2]=c[0]+c[1],c.shift(),a--;if(a)for(c=[BigInt(c[0]),BigInt(c[1])];a--;)c[2]=c[0].plus(c[1]),c.shift();return b?c:c[0]};
        Fib={clear:function(){Fib.wait=!1;mr("fibInp").value=""},counter:1,demo:function(){mr("calcfibBtn").onclick=Fib.buttonClick},discomma:!!window.opera,buttonClick:function(){var a=mr("fibInp").value;console.time("fibon test");for(var b=0;b<parseInt(a);b++)Fib.getFib(b);console.timeEnd("fibon test")},getFib:function(a){var b,c;a=parseInt(a);if(!a||2>a)return mr("fibInp").focus(),!0;if(1100>=a)return b=Math.nthFibonacci(a).toString(),Fib.report(["",a,b.length,b]),!0;if(1E4<a&&(b=Fib,c=b.counter,2E3<c))return Fib.reach(b.low,
            b.high,a,c,Fib.report),!0;b=Math.nthFibonacci(1E3,1);Fib.reach(b[0],b[1],a,1E3,Fib.report);return!0},high:1,keycheck:function(a){a=a||window.event;13==(a.charCode||a.keyCode)&&Fib.getFib();return!0},low:0,quitFib:function(){Fib.wait=!0},reach:function(a,b,c,f,e){var g,d=Fib.reach;void 0===d.time&&(d.top=c,d.count=f+1,d.time=(new Date).getTime(),d.cb=e,d.tik=!1);c=b.toString().length;if(f=mr("yw_fib_tex"))f.value=2100>c?b:c+" digits...thinking...";c=2E4<c?1E5<c?10:20:5E3<c?1E4<c?50:100:1E3<c?200:1E3;
        navigator.IEmod&&(c/=4);for(c=Math.min(c,d.top-d.count);0<c;)g=BigInt(a).plus(b),d.count++,a=b,b=g,--c;if(d.count>=d.top||Fib.wait){if(b=(new Date-d.time)/1E3,g=g.toString(),b=[b,d.count,g.length,g,a],d.time=void 0,"function"==typeof d.cb)return d.cb(b)}else setTimeout(function(){d(a,g)},0)},report:function(a){var b=Fib,c=a[1],f=a[0]||"",e=a[3];f&&(f+=b.time,Fib.time=b.wait?Fib.time+f:0,f.toFixed(3));a[4]&&e>b.counter&&(b.counter=c,b.low=a[4],b.high=e);e=e.toString();window.opera&&(e=e.replace(/(\d{10})/g,
            "$1 "));console.log(e+"\n");Fib.wait=!1;return!0},time:0,wait:!1};window.onload=function(){Fib.demo()};
        </script>
    </body>
    </html>